using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace ComTools
{
    public partial class frmMain : Form
    {
        delegate void StrDelegate(string iStr);

        public frmMain()
        {
            InitializeComponent();
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            for (int i = 1; i < 10; i++)
            {
                this.cboPort.Items.Add("COM" + i.ToString());
            }
            this.cboPort.SelectedIndex = 0;
            this.cboRate.Items.Add("4800");
            this.cboRate.Items.Add("9600");
            this.cboRate.Items.Add("19200");
            this.cboRate.Items.Add("38400");
            this.cboRate.Items.Add("56000");
            this.cboRate.Items.Add("115200");
            this.cboRate.SelectedIndex=2;

            this.cboChksumEn.SelectedIndex = 0;
            this.cboGpsMode.SelectedIndex = 0;
            this.cboGpsMsg.SelectedIndex = 0;
            this.cboGpsMsgID.SelectedIndex = 3;

            this.chkAutoScroll.Checked = true;
            
        }

        private void Write_Str_To_RxTxt(string iStr)
        {
            try
            {
                if (this.txtRxData.InvokeRequired)
                {
                    StrDelegate CallMeBack = new StrDelegate(Write_Str_To_RxTxt);
                    this.Invoke(CallMeBack, new object[] { iStr });
                }
                else
                {
                    this.txtRxData.AppendText(iStr);
                }
            }
            catch { }
            

        }
        private void Write_Str_To_TxTxt(string iStr)
        {
            try
            {
                if (this.txtTxData.InvokeRequired)
                {
                    StrDelegate CallMeBack = new StrDelegate(Write_Str_To_TxTxt);
                    this.Invoke(CallMeBack, new object[] { iStr });
                }
                else
                {
                    this.txtTxData.Text=iStr;
                }
            }
            catch { }


        }
        byte[] SerialPort_Rx_Buffer = new byte[512];
        string SerialPort_Rx_Buffer_Str = null;
        private void serialPort_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            if (serialPort.IsOpen)
            {
                SerialPort_Rx_Buffer_Str = serialPort.ReadLine();
                Write_Str_To_RxTxt(SerialPort_Rx_Buffer_Str);
            }
        }

        private void btnOnOffPort_Click(object sender, EventArgs e)
        {
            if (serialPort.IsOpen)
            {
                serialPort.Close();
                btnOnOffPort.Text = "Open";
            }
            else
            {

                serialPort.PortName = cboPort.SelectedItem.ToString();
                serialPort.BaudRate = Convert.ToInt16(cboRate.SelectedItem.ToString());
                serialPort.Parity = Parity.None;
                serialPort.StopBits = StopBits.One;
                serialPort.DataBits = 8;
                serialPort.Open();
                btnOnOffPort.Text = "Close";
            }
        }

        private void frmMain_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (serialPort.IsOpen)
            {
                serialPort.Close();
            }

        }

        private void btnEncode_Click(object sender, EventArgs e)
        {
            string CMDStr = null;
            CMDStr = "$PSRF10";
            CMDStr += cboGpsMsgID.SelectedIndex.ToString("D");
            CMDStr += "," + cboGpsMsg.SelectedIndex.ToString("D2");
            CMDStr += "," + cboGpsMode.SelectedIndex.ToString("D2");
            CMDStr += "," + Convert.ToInt16(numGpsRate.Value).ToString("D2");
            CMDStr += "," + cboChksumEn.SelectedIndex.ToString("D2");
            byte chknum;
            byte[] bytCMD = Encoding.ASCII.GetBytes(CMDStr);
            chknum = bytCMD[1];
            for (int i = 2; i < bytCMD.Length; i++)
            {
                chknum ^= bytCMD[i];
            }
            CMDStr += "*" + chknum.ToString("X2");
            CMDStr += "\r"+"\n";
            Write_Str_To_TxTxt(CMDStr);

        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            byte[] bytStr = Encoding.ASCII.GetBytes(txtTxData.Text.ToString());
            if(serialPort.IsOpen)            serialPort.Write(bytStr, 0, bytStr.Length);
        }

        private void lnkClearRxTXT_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            txtRxData.Text = "";
        }

        private void txtRxData_TextChanged(object sender, EventArgs e)
        {
            if (txtRxData.Text.Length > 32760) txtRxData.Text = "";
            if(chkAutoScroll.Checked) this.txtRxData.ScrollToCaret();
        }


    }
}